// RiffSIF.cpp: CRiffSIF NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"		// C V{
#include "GlobalCommand.h"
#include "RiffSIF.h"


extern int nId3v2VersionNew;
extern int nId3v2EncodeNew;
extern bool		bOptUnSyncNew;


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CRiffSIF::CRiffSIF()
{
	Release();
}

CRiffSIF::~CRiffSIF()
{

}

void CRiffSIF::Release()
{
	m_dwStreamSize = 0;
	m_bEnable = FALSE;
	m_fields.clear();
}

BOOL CRiffSIF::SetField(char id1,char id2,char id3,char id4,LPCTSTR szData)
{
	m_fields.erase(mmioFOURCC(id1,id2,id3,id4));
	if(lstrlen(szData))
	{
		m_fields.insert(pair<FOURCC,CString>(mmioFOURCC(id1,id2,id3,id4),szData));
	}
	return TRUE;
}

CString CRiffSIF::GetField(char id1,char id2,char id3,char id4)
{
	map<FOURCC,CString>::iterator p;
	p = m_fields.find(mmioFOURCC(id1,id2,id3,id4));
	if(p == m_fields.end())
	{
		return _T("");
	}
	return p->second;
}

DWORD CRiffSIF::GetTotalFieldSize()
{
	DWORD dwSize = 0;
	map<FOURCC,CString>::iterator p;

	p = m_fields.begin();
	while(p != m_fields.end())
	{
		CString *pStr = &p->second;
		DWORD len = TstrToData(*pStr, -1, NULL, 0, DTC_CODE_ANSI);
		dwSize += len + (len&0x1)?1:0;	//WORDE킹
		p++;
	}
	return dwSize;
}

//`N܂
//return=TRUÊƂ͌`N̐擪+8̈ʒuɂ܂
//return=FALSÊƂ͍ŏI`N̍Ō+1
BOOL CRiffSIF::FindChunk(HANDLE hFile,DWORD dwFileSize,UINT flag,FOURCC type,DWORD *pdwSize,BOOL bModify)
{
	FOURCC id;
	FOURCC fType;
	DWORD dwRet;
	DWORD dwSize;
	LONG lAddressHeight;
	// 1G = 1073741824
	// 2G = 2147483648
	// 4G = 4294967296

	while(1)
	{
		DWORD dwChunkHead = SetFilePointer(hFile,0,NULL,FILE_CURRENT);
		if(!ReadFile(hFile,&id,sizeof(id),&dwRet,NULL) || (dwRet != sizeof(id)))
		{
			lAddressHeight = 0;
			SetFilePointer(hFile,dwChunkHead,&lAddressHeight,FILE_BEGIN);
			return FALSE;
		}
		if(!ReadFile(hFile,&dwSize,sizeof(dwSize),&dwRet,NULL) || (dwRet != sizeof(dwSize)))
		{
			lAddressHeight = 0;
			SetFilePointer(hFile,dwChunkHead,&lAddressHeight,FILE_BEGIN);
			return FALSE;
		}
		if(dwSize%2)
		{
			dwSize++;
		}
		*pdwSize = dwSize;
		switch(id){
		case FOURCC_RIFF:
			if(!ReadFile(hFile,&fType,sizeof(fType),&dwRet,NULL) || (dwRet != sizeof(fType)))
			{
				lAddressHeight = 0;
				SetFilePointer(hFile,dwChunkHead,&lAddressHeight,FILE_BEGIN);
				return FALSE;
			}
			*pdwSize -= sizeof(fType);
			if(flag != MMIO_FINDRIFF)
			{
				break;
			}
			if(fType == type)
			{
				return TRUE;
			}
			break;
			
		case FOURCC_LIST:
			if(!ReadFile(hFile,&fType,sizeof(fType),&dwRet,NULL) || (dwRet != sizeof(fType)))
			{
				lAddressHeight = 0;
				SetFilePointer(hFile,dwChunkHead,&lAddressHeight,FILE_BEGIN);
				return FALSE;
			}
			*pdwSize -= sizeof(fType);
			if(flag != MMIO_FINDLIST)
			{
				break;
			}
			if(fType == type)
			{
				return TRUE;
			}
			break;
			
		default:
			if(id == type)
			{
				return TRUE;
			}
			break;
		}
		TRACE(_T("%c%c%c%c %c%c%c%c %lu(%lu)\n"),
			(((char *)(&id))[0]),(((char *)(&id))[1]),(((char *)(&id))[2]),(((char *)(&id))[3]),
			(((char *)(&fType))[0]),(((char *)(&fType))[1]),(((char *)(&fType))[2]),(((char *)(&fType))[3]),
			dwChunkHead,dwSize
			);
		if(bModify)
		{
			if((dwChunkHead+8+dwSize) > dwFileSize)
			{
				//Ō̃`NTCYsiCj
				// ۂ̃t@CTCYA`NTCY̏I[ɂĂ
				// ߂Ƀ`NTCYt@CTCY܂ŕ␳
				dwSize -= (dwChunkHead+8+dwSize) - dwFileSize;
				lAddressHeight = 0;
				SetFilePointer(hFile,dwChunkHead+4,&lAddressHeight,FILE_BEGIN);
				DWORD dwRet;
				WriteFile(hFile,&dwSize,sizeof(dwSize),&dwRet,NULL);
				lAddressHeight = 0;
				SetFilePointer(hFile,dwSize,&lAddressHeight,FILE_CURRENT);
				return FALSE;
			}
		}
		lAddressHeight = 0;
		SetFilePointer(hFile,*pdwSize,&lAddressHeight,FILE_CURRENT);

	}
	return FALSE;
}

/*
	ׂĂ"INAM(SIZE)::::::"̒
*/
DWORD CRiffSIF::GetInfoChunkSize()
{
	DWORD dwSize = 0; 
	map<FOURCC,CString>::iterator p = m_fields.begin();
	while(p != m_fields.end())
	{
		FOURCC id = p->first;
		CString *pStr = &p->second;
		DWORD len = TstrToData(*pStr, -1, NULL, 0, DTC_CODE_ANSI);
		dwSize += len + 8 + ((len%2)?1:0);
		p++;
	}

	return dwSize;
}
/*
	ret:	-1 = [hs
			-2 = t@CTCY2G𒴉߂Ă
*/
DWORD CRiffSIF::Load(LPCTSTR szFileName,char id1,char id2,char id3,char id4)
{
	DWORD	dwWin32errorCode = ERROR_SUCCESS;
	HANDLE hFile;
	DWORD dwRet;
	DWORD dwTotalSize;
	__int64 llFileSize;
	FOURCC id,type;

	DWORD dwSize;
	DWORD dwPtr;

	map<FOURCC,CString>::iterator p;

	Release();
	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	//t@CJ
	hFile = CreateFile(szFileName,
					GENERIC_READ,
					FILE_SHARE_READ,NULL,
					OPEN_EXISTING,	//t@CJ܂Bw肵t@C݂ĂȂꍇÅ֐͎s܂B 
					FILE_ATTRIBUTE_NORMAL,
					NULL);
	if(hFile == INVALID_HANDLE_VALUE)
	{
		dwWin32errorCode = GetLastError();
		goto exit;
	}
	
	llFileSize = GetFileSize64(hFile);
	if(llFileSize >= 0x80000000)
	{
		// 2G𒴂t@C͓ǂݎȂ
		dwWin32errorCode = -2;
		goto exit;
	}

	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	//RIFF-AVI mF
	if(!ReadFile(hFile,&id,sizeof(id),&dwRet,NULL))
	{
		dwWin32errorCode = GetLastError();
		goto exit;
	}
	// TCY
	if(!ReadFile(hFile,&dwTotalSize,sizeof(dwTotalSize),&dwRet,NULL))
	{
		dwWin32errorCode = GetLastError();
		goto exit;
	}
	// Riff type
	if(!ReadFile(hFile,&type,sizeof(type),&dwRet,NULL))
	{
		dwWin32errorCode = GetLastError();
		goto exit;
	}
	m_type = mmioFOURCC(id1,id2,id3,id4);
	if((FOURCC_RIFF != id) || (m_type != type))
	{
		dwWin32errorCode = GetLastError();
		goto exit;
	}
	m_bEnable = TRUE;

	dwPtr = SetFilePointer(hFile,0,NULL,FILE_CURRENT);
	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	//data`N(ȂƂRiff_I[Ɉړ)
	if(FindChunk(hFile,(DWORD)llFileSize,MMIO_FINDCHUNK,mmioFOURCC('d','a','t','a'),&dwSize,FALSE) && (dwSize > 8))
	{
		// (`N̐擪+8ɂ)
		m_dwStreamSize = dwSize;
	}
	SetFilePointer(hFile,dwPtr,NULL,FILE_BEGIN);
	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	//LIST-INFO(ȂƂRiff_I[ɈړE`NTCYC@\t)
	if(FindChunk(hFile,(DWORD)llFileSize,MMIO_FINDLIST,mmioFOURCC('I','N','F','O'),&dwSize,FALSE) && (dwSize > 8))
	{
		// (`N̐擪+12ɂ)
		
		//SĂ̏荞
		char *buf = (char *)malloc(dwSize);
		if(buf == NULL)
		{
			dwWin32errorCode = -1;
			goto exit;
		}
		if(!ReadFile(hFile,buf,dwSize,&dwRet,NULL))
		{
			dwWin32errorCode = GetLastError();
			free(buf);
			goto exit;
		}
		
		DWORD dwRemainSize = dwSize;
		while(dwRemainSize > 0)
		{
			if(dwRemainSize < 8)
			{
				break;	//pS
			}
			FOURCC id =	mmioFOURCC(
								buf[dwSize-dwRemainSize],
								buf[dwSize-dwRemainSize+1],
								buf[dwSize-dwRemainSize+2],
								buf[dwSize-dwRemainSize+3]
								);
			DWORD size = *(DWORD *)&buf[dwSize-dwRemainSize+4];
			char *data = (char *)&buf[dwSize-dwRemainSize+8];
			if(dwRemainSize < (8+size))
			{
				break;	//pS
			}
			if(size>0)
			{
				//mapɒǉ
				if(data[size-1] == '\0')
				{
					m_fields.insert(pair<FOURCC,CString>(id,data));
				}
				else
				{
					m_fields.insert(pair<FOURCC,CString>(id,CString(data,size)));
				}
			}
			if(dwRemainSize <= (size+8))
			{
				break;
			}
			dwRemainSize -= size + 8;
			if(dwRemainSize & 0x01)
			{
				dwRemainSize--;	//[hE킹
			}
		}
		free(buf);
	}

	SetFilePointer(hFile,dwPtr,NULL,FILE_BEGIN);
	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	//ID3v2.3.0(ȂƂRiff_I[ɈړE`NTCYC@\t)
	if(FindChunk(hFile,(DWORD)llFileSize,MMIO_FINDCHUNK,mmioFOURCC('i','d','3',' '),&dwSize,FALSE) && (dwSize > 8))
	{
		// (`N̐擪+8ɂ)

        //SĂ̏荞
        char *buf = (char *)malloc(dwSize);
        if (buf == NULL) {
            dwWin32errorCode = -1;
            goto exit;
        }
        if (!ReadFile(hFile, buf, dwSize, &dwRet, NULL)) {
            dwWin32errorCode = GetLastError();
            free(buf);
            goto exit;
        }

        m_id3tag.Read((BYTE*)buf, dwSize);

        free(buf);
    }

exit:

	if(hFile != INVALID_HANDLE_VALUE)
	{
		CloseHandle(hFile);
	}

	return dwWin32errorCode;
}


/*
	ret:	-1 = XVs
			-2 = t@CTCY2G𒴉߂Ă
*/
DWORD CRiffSIF::Save(HWND hWnd,LPCTSTR szFileName)
{
	DWORD	dwWin32errorCode = ERROR_SUCCESS;

	DWORD dwRet;

    //==================t@Cɕۑ==================
    DWORD dwDataSize;
    char* pRawData;
    {
        HANDLE hFile = CreateFile(
            szFileName,
            GENERIC_READ,
            FILE_SHARE_READ,
            NULL,
            OPEN_EXISTING,	//wt@C݂ĂȂꍇA֐͎s܂B
            FILE_ATTRIBUTE_NORMAL,
            NULL);
        if (hFile == INVALID_HANDLE_VALUE) {
            dwWin32errorCode = GetLastError();
            return dwWin32errorCode;
        }
        dwDataSize = GetFileSize(hFile, NULL);
        //obt@̊m
        pRawData = (char *)malloc(dwDataSize);
        if (!pRawData) {
            dwWin32errorCode = GetLastError();
            CloseHandle(hFile);
            return dwWin32errorCode;
        }
        //raw data̓ǂݏo
        DWORD   dwWritten;
        if (!ReadFile(hFile, pRawData, dwDataSize, &dwWritten, NULL)) {
            dwWin32errorCode = GetLastError();
            CloseHandle(hFile);
            free(pRawData);
            return dwWin32errorCode;
        }
        CloseHandle(hFile);
    }

    //==================e|쐬==================
    //e|擾
    HANDLE hFile;
    TCHAR szTempFile[MAX_PATH];
    TCHAR szTempPath[MAX_PATH];
    lstrcpy(szTempPath, szFileName);
    cutFileName(szTempPath);
    if (!GetTempFileName(szTempPath, _T("tms"), 0, szTempFile)) {
        dwWin32errorCode = GetLastError();
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }
    //t@CI[v(wt@Cłɑ݂ĂꍇÃt@C͏㏑܂B)
    hFile = CreateFile(szTempFile, GENERIC_WRITE | GENERIC_READ, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    if (hFile == INVALID_HANDLE_VALUE) {
        dwWin32errorCode = GetLastError();
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }
    //܂Ȃ
    if (SetFilePointer(hFile, 0, NULL, FILE_BEGIN) == INVALID_SET_FILE_POINTER) {
        dwWin32errorCode = GetLastError();
        CloseHandle(hFile);
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }

	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	//RIFF-AVI mF
    struct RiffHead {
        FOURCC id;
        DWORD dwTotalSize;
        FOURCC type;
    };
    if (dwDataSize < sizeof(RiffHead)) {
        dwWin32errorCode = GetLastError();
        CloseHandle(hFile);
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }
    RiffHead* pHead = (RiffHead*)pRawData;
	if((FOURCC_RIFF != pHead->id) || (m_type != pHead->type))
	{
        dwWin32errorCode = GetLastError();
        CloseHandle(hFile);
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }
    WriteFile(hFile, pHead, sizeof(RiffHead), &dwRet, NULL);
    
    auto WriteId3Tag = [this](HANDLE hFile)
    {
        std::vector<BYTE> vec;
        m_id3tag.Write(vec);
        if (vec.size() > 10) {
            DWORD dwRet;
            const FOURCC chunkId = mmioFOURCC('i', 'd', '3', ' ');
            const DWORD dwWriteChunkSize = static_cast<DWORD>(vec.size());
            if (vec.size() % 2) {
                vec.push_back(0);
            }
            WriteFile(hFile, &chunkId, sizeof(FOURCC), &dwRet, NULL);
            WriteFile(hFile, &dwWriteChunkSize, sizeof(dwWriteChunkSize), &dwRet, NULL);
            WriteFile(hFile, &vec[0], static_cast<DWORD>(vec.size()), &dwRet, NULL);
        }
    };
    auto WriteRiffInfo = [this](HANDLE hFile)
    {
        const DWORD dwInfoSize = GetInfoChunkSize();
        if (dwInfoSize > 0) {
            DWORD dwRet;
            const FOURCC chunkId = FOURCC_LIST;
            const DWORD dwWriteChunkSize = dwInfoSize + 4;
            const FOURCC chunkType = mmioFOURCC('I', 'N', 'F', 'O');
            WriteFile(hFile, &chunkId, sizeof(chunkId), &dwRet, NULL);
            WriteFile(hFile, &dwWriteChunkSize, sizeof(dwWriteChunkSize), &dwRet, NULL);
            WriteFile(hFile, &chunkType, sizeof(chunkType), &dwRet, NULL);
            //SẴtB[hۑ
            for (auto p = m_fields.begin(); p != m_fields.end(); ++p) {
                FOURCC subChunkId = p->first;
                CString *pStr = &p->second;
                DWORD dwSubChunkSize;
                char *str = TstrToDataAlloc(*pStr, -1, (int*)&dwSubChunkSize, DTC_CODE_ANSI);
                if (str) {
                    if (dwSubChunkSize > 1) {
                        WriteFile(hFile, &subChunkId, sizeof(subChunkId), &dwRet, NULL);
                        WriteFile(hFile, &dwSubChunkSize, sizeof(dwSubChunkSize), &dwRet, NULL);
                        WriteFile(hFile, str, dwSubChunkSize, &dwRet, NULL);
                        if (dwSubChunkSize % 2) {
                            WriteFile(hFile, "\x00", 1, &dwRet, NULL);
                        }
                    }
                    free(str);
                }
            }
        }
    };
    DWORD dwPos = 12;
    bool id3Written = false;
    bool infoWritten = false;
    while (dwDataSize - dwPos >= 8) {
        const DWORD dwChunkHead = dwPos;
        FOURCC chunkId;
        memcpy(&chunkId, &pRawData[dwChunkHead], sizeof(chunkId));
        DWORD dwChunkSize;
        memcpy(&dwChunkSize, &pRawData[dwChunkHead + 4], sizeof(dwChunkSize));
        if (dwChunkSize % 2) {
            dwChunkSize++;
        }
        if (dwChunkSize + 8 > dwDataSize - dwChunkHead) {
            break;
        }
        FOURCC chunkType;
        switch (chunkId) {
        case mmioFOURCC('i', 'd', '3', ' '):
            if (!id3Written) {
                if (m_id3tag.IsEnable()) {
                    WriteId3Tag(hFile);
                }
                id3Written = true;
            } else {
                WriteFile(hFile, &pRawData[dwChunkHead], 8 + dwChunkSize, &dwRet, NULL);
            }
            break;
        case FOURCC_LIST:
            memcpy(&chunkType, &pRawData[dwChunkHead + 8], sizeof(chunkType));
            if (!infoWritten && (chunkType == mmioFOURCC('I', 'N', 'F', 'O'))) {
                WriteRiffInfo(hFile);
                infoWritten = true;
            } else {
                WriteFile(hFile, &pRawData[dwChunkHead], 8 + dwChunkSize, &dwRet, NULL);
            }
            break;
        default:
            WriteFile(hFile, &pRawData[dwChunkHead], 8 + dwChunkSize, &dwRet, NULL);
            break;
        }
        dwPos = dwChunkHead + 8 + dwChunkSize;
    }
    if (!id3Written) {
        if (m_id3tag.IsEnable()) {
            WriteId3Tag(hFile);
        }
    }
    if (!infoWritten) {
        WriteRiffInfo(hFile);
    }

	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	//t@CTCYC(LIST-INFO݂)
    const DWORD dwRiffChunkSize = SetFilePointer(hFile,0,NULL,FILE_CURRENT) - 8;
	if(!SetEndOfFile(hFile))
	{
        dwWin32errorCode = GetLastError();
        CloseHandle(hFile);
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }

	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	//RIFF-AVI `NTCYC
	SetFilePointer(hFile,4,NULL,FILE_BEGIN);
	WriteFile(hFile,&dwRiffChunkSize,sizeof(dwRiffChunkSize),&dwRet,NULL);

    CloseHandle(hFile);
    free(pRawData);

    //IWit@Cޔ(l[)
    TCHAR szPreFile[MAX_PATH];
    if (!GetTempFileName(szTempPath, _T("tms"), 0, szPreFile)) {
        dwWin32errorCode = GetLastError();
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }
    DeleteFile(szPreFile);//蔲(^^;
    if (!MoveFile(szFileName, szPreFile)) {
        dwWin32errorCode = GetLastError();
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }

    //il[
    if (!MoveFile(szTempFile, szFileName)) {
        dwWin32errorCode = GetLastError();
        MoveFile(szPreFile, szFileName);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }

    //IWi폜
    DeleteFile(szPreFile);

	return dwWin32errorCode;
}

DWORD ProcessWavTag(LPCTSTR szFileName, WavProcessMode mode)
{
    DWORD	dwWin32errorCode = ERROR_SUCCESS;

    DWORD dwRet;

    //==================t@Cɕۑ==================
    DWORD dwDataSize;
    char* pRawData;
    {
        HANDLE hFile = CreateFile(
            szFileName,
            GENERIC_READ,
            FILE_SHARE_READ,
            NULL,
            OPEN_EXISTING,	//wt@C݂ĂȂꍇA֐͎s܂B
            FILE_ATTRIBUTE_NORMAL,
            NULL);
        if (hFile == INVALID_HANDLE_VALUE) {
            dwWin32errorCode = GetLastError();
            return dwWin32errorCode;
        }
        dwDataSize = GetFileSize(hFile, NULL);
        //obt@̊m
        pRawData = (char *)malloc(dwDataSize);
        if (!pRawData) {
            dwWin32errorCode = GetLastError();
            CloseHandle(hFile);
            return dwWin32errorCode;
        }
        //raw data̓ǂݏo
        DWORD   dwWritten;
        if (!ReadFile(hFile, pRawData, dwDataSize, &dwWritten, NULL)) {
            dwWin32errorCode = GetLastError();
            CloseHandle(hFile);
            free(pRawData);
            return dwWin32errorCode;
        }
        CloseHandle(hFile);
    }

    //==================e|쐬==================
    //e|擾
    HANDLE hFile;
    TCHAR szTempFile[MAX_PATH];
    TCHAR szTempPath[MAX_PATH];
    lstrcpy(szTempPath, szFileName);
    cutFileName(szTempPath);
    if (!GetTempFileName(szTempPath, _T("tms"), 0, szTempFile)) {
        dwWin32errorCode = GetLastError();
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }
    //t@CI[v(wt@Cłɑ݂ĂꍇÃt@C͏㏑܂B)
    hFile = CreateFile(szTempFile, GENERIC_WRITE | GENERIC_READ, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    if (hFile == INVALID_HANDLE_VALUE) {
        dwWin32errorCode = GetLastError();
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }
    //܂Ȃ
    if (SetFilePointer(hFile, 0, NULL, FILE_BEGIN) == INVALID_SET_FILE_POINTER) {
        dwWin32errorCode = GetLastError();
        CloseHandle(hFile);
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }

    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    //RIFF-AVI mF
    struct RiffHead
    {
        FOURCC id;
        DWORD dwTotalSize;
        FOURCC type;
    };
    if (dwDataSize < sizeof(RiffHead)) {
        dwWin32errorCode = GetLastError();
        CloseHandle(hFile);
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }
    RiffHead* pHead = (RiffHead*)pRawData;
    if ((FOURCC_RIFF != pHead->id) || (mmioFOURCC('W', 'A', 'V', 'E') != pHead->type)) {
        dwWin32errorCode = GetLastError();
        CloseHandle(hFile);
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }
    WriteFile(hFile, pHead, sizeof(RiffHead), &dwRet, NULL);

    DWORD dwPos = 12;
    bool id3Encountered = false;
    switch (mode) {
    case WavAppendId3Tag:
        while (dwDataSize - dwPos >= 8) {
            const DWORD dwChunkHead = dwPos;
            FOURCC chunkId;
            memcpy(&chunkId, &pRawData[dwChunkHead], sizeof(chunkId));
            DWORD dwChunkSize;
            memcpy(&dwChunkSize, &pRawData[dwChunkHead + 4], sizeof(dwChunkSize));
            if (dwChunkSize % 2) {
                dwChunkSize++;
            }
            if (dwChunkSize + 8 > dwDataSize - dwChunkHead) {
                break;
            }
            FOURCC chunkType;
            switch (chunkId) {
            case mmioFOURCC('i', 'd', '3', ' '):
                id3Encountered = true;
                // fall through
            default:
                WriteFile(hFile, &pRawData[dwChunkHead], 8 + dwChunkSize, &dwRet, NULL);
                break;
            }
            dwPos = dwChunkHead + 8 + dwChunkSize;
        }
        if (!id3Encountered) {
            CId3tagv2 tag;

            switch (nId3v2VersionNew) {
            case 0: // v2.2
                tag.SetVer(0x0200);
                break;
            case 1: // v2.3
                tag.SetVer(0x0300);
                break;
            case 2: // v2.4
                tag.SetVer(0x0400);
                break;
            default:
                break;
            }
            switch (nId3v2EncodeNew) {
            case 0:
                tag.SetCharEncode(CId3tagv2::ID3V2CHARENCODE_ISO_8859_1);
                break;
            case 1:
                tag.SetCharEncode(CId3tagv2::ID3V2CHARENCODE_UTF_16);
                break;
            case 2:
                tag.SetCharEncode(CId3tagv2::ID3V2CHARENCODE_UTF_8);
                break;
                //case 3:
                //  id3v2.SetCharEncode(CId3tagv2::ID3V2CHARENCODE_UTF_16BE);
                //  break;
            default:
                break;
            }
            tag.SetUnSynchronization(bOptUnSyncNew ? TRUE : FALSE);
            tag.SetEnable(TRUE);

            //ftHg
            TCHAR szDefaultName[MAX_PATH];
            CString strFileName = szFileName;
            lstrcpy(szDefaultName, getFileName(strFileName));
            tag.SetTitle(szDefaultName);

            std::vector<BYTE> vec;
            tag.Write(vec);
            const FOURCC chunkId = mmioFOURCC('i', 'd', '3', ' ');
            const DWORD dwWriteChunkSize = static_cast<DWORD>(vec.size());
            if (vec.size() % 2) {
                vec.push_back(0);
            }
            WriteFile(hFile, &chunkId, sizeof(FOURCC), &dwRet, NULL);
            WriteFile(hFile, &dwWriteChunkSize, sizeof(dwWriteChunkSize), &dwRet, NULL);
            WriteFile(hFile, &vec[0], static_cast<DWORD>(vec.size()), &dwRet, NULL);
        }
        break;
    case WavRemoveId3Tag:
        while (dwDataSize - dwPos >= 8) {
            const DWORD dwChunkHead = dwPos;
            FOURCC chunkId;
            memcpy(&chunkId, &pRawData[dwChunkHead], sizeof(chunkId));
            DWORD dwChunkSize;
            memcpy(&dwChunkSize, &pRawData[dwChunkHead + 4], sizeof(dwChunkSize));
            if (dwChunkSize % 2) {
                dwChunkSize++;
            }
            if (dwChunkSize + 8 > dwDataSize - dwChunkHead) {
                break;
            }
            FOURCC chunkType;
            switch (chunkId) {
            case mmioFOURCC('i', 'd', '3', ' '):
                break;
            default:
                WriteFile(hFile, &pRawData[dwChunkHead], 8 + dwChunkSize, &dwRet, NULL);
                break;
            }
            dwPos = dwChunkHead + 8 + dwChunkSize;
        }
        break;
    case WavRemoveAllTags:
        while (dwDataSize - dwPos >= 8) {
            const DWORD dwChunkHead = dwPos;
            FOURCC chunkId;
            memcpy(&chunkId, &pRawData[dwChunkHead], sizeof(chunkId));
            DWORD dwChunkSize;
            memcpy(&dwChunkSize, &pRawData[dwChunkHead + 4], sizeof(dwChunkSize));
            if (dwChunkSize % 2) {
                dwChunkSize++;
            }
            if (dwChunkSize + 8 > dwDataSize - dwChunkHead) {
                break;
            }
            FOURCC chunkType;
            switch (chunkId) {
            case mmioFOURCC('f', 'm', 't', ' '):
            case mmioFOURCC('d', 'a', 't', 'a'):
                WriteFile(hFile, &pRawData[dwChunkHead], 8 + dwChunkSize, &dwRet, NULL);
                break;
            default:
                break;
            }
            dwPos = dwChunkHead + 8 + dwChunkSize;
        }
        break;
    case WavRemoveJunkChunks:
        while (dwDataSize - dwPos >= 8) {
            const DWORD dwChunkHead = dwPos;
            FOURCC chunkId;
            memcpy(&chunkId, &pRawData[dwChunkHead], sizeof(chunkId));
            DWORD dwChunkSize;
            memcpy(&dwChunkSize, &pRawData[dwChunkHead + 4], sizeof(dwChunkSize));
            if (dwChunkSize % 2) {
                dwChunkSize++;
            }
            if (dwChunkSize + 8 > dwDataSize - dwChunkHead) {
                break;
            }
            FOURCC chunkType;
            switch (chunkId) {
            case mmioFOURCC('J', 'U', 'N', 'K'):
                break;
            default:
                WriteFile(hFile, &pRawData[dwChunkHead], 8 + dwChunkSize, &dwRet, NULL);
                break;
            }
            dwPos = dwChunkHead + 8 + dwChunkSize;
        }
        break;
    }

    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    //t@CTCYC(LIST-INFO݂)
    const DWORD dwRiffChunkSize = SetFilePointer(hFile, 0, NULL, FILE_CURRENT) - 8;
    if (!SetEndOfFile(hFile)) {
        dwWin32errorCode = GetLastError();
        CloseHandle(hFile);
        free(pRawData);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }

    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    //RIFF-AVI `NTCYC
    SetFilePointer(hFile, 4, NULL, FILE_BEGIN);
    WriteFile(hFile, &dwRiffChunkSize, sizeof(dwRiffChunkSize), &dwRet, NULL);

    CloseHandle(hFile);
    free(pRawData);

    //IWit@Cޔ(l[)
    TCHAR szPreFile[MAX_PATH];
    if (!GetTempFileName(szTempPath, _T("tms"), 0, szPreFile)) {
        dwWin32errorCode = GetLastError();
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }
    DeleteFile(szPreFile);//蔲(^^;
    if (!MoveFile(szFileName, szPreFile)) {
        dwWin32errorCode = GetLastError();
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }

    //il[
    if (!MoveFile(szTempFile, szFileName)) {
        dwWin32errorCode = GetLastError();
        MoveFile(szPreFile, szFileName);
        DeleteFile(szTempFile);
        return dwWin32errorCode;
    }

    //IWi폜
    DeleteFile(szPreFile);

    return dwWin32errorCode;
}

