#include "stdafx.h"
#include "RiffSif.h"
#include "STEPlugin.h"
#include "MMCommand.h"
#include "GlobalCommand.h"

#include "mp3infp_ExportFunc.h"

extern int     nId3v2Encode;
extern int     nId3v2Version;
extern int     nId3v2EncodeNew;
extern int     nId3v2VersionNew;

extern UINT nFileTypeWAV;
extern UINT nFileTypeWAVV22;
extern UINT nFileTypeWAVV23;
extern UINT nFileTypeWAVV24;
extern UINT nFileTypeAVI;


//WAV  AVI ̃^Oǂݏ
//{I WAV  AVI 
bool LoadAttributeFileWAV(FILE_INFO *pFileMP3);
bool WriteAttributeFileWAV(FILE_INFO *pFileMP3);

bool LoadAttributeFileWAV(FILE_INFO *pFileMP3)
{
	CRiffSIF riff;
	TCHAR ext[_MAX_EXT];
	_tsplitpath(GetFullPath(pFileMP3), NULL, NULL, NULL, ext);
    if(_tcsicmp(ext, _T(".wav")) == 0){
        if(riff.Load(GetFullPath(pFileMP3),'W','A','V','E') != ERROR_SUCCESS){
            return false;
        }
    }
    else if(_tcsicmp(ext, _T(".avi")) == 0){
        if(riff.Load(GetFullPath(pFileMP3),'A','V','I',' ') != ERROR_SUCCESS){
            return false;
        }
	    //ISBJ songname
	    SetTrackName(pFileMP3, riff.GetField('I','S','B','J'));
    }
    else{
        return false;
    }
    //INAM/ISBJ ^Cg
    //ISBJ  INAM D
    SetTrackName(pFileMP3, riff.GetField('I','N','A','M'));
    if(_tcslen(GetTrackName(pFileMP3)) == 0){
        SetTrackName(pFileMP3, riff.GetField('I','S','B','J'));
    }
	//IART A[eBXg
	SetArtistName(pFileMP3, riff.GetField('I','A','R','T'));
	//IPRD Ao
	SetAlbumName(pFileMP3, riff.GetField('I','P','R','D'));
	//ICMT Rg
	SetComment(pFileMP3, riff.GetField('I','C','M','T'));
	//ICRD t
	SetYear(pFileMP3, riff.GetField('I','C','R','D'));
	//IGNR W
	SetGenre(pFileMP3, riff.GetField('I','G','N','R'));
	//ITRK gbNԍ
	SetTrackNumber(pFileMP3, riff.GetField('I','T','R','K'));

    if (riff.m_id3tag.IsEnable()) {
        SetTrackNameSI(pFileMP3, riff.m_id3tag.GetTitle());     // ^Cg
        SetArtistNameSI(pFileMP3, riff.m_id3tag.GetArtist());   // A[eBXg
        SetAlbumNameSI(pFileMP3, riff.m_id3tag.GetAlbum());     // Ao
        SetYearSI(pFileMP3, riff.m_id3tag.GetYear());           // [X
        SetCommentSI(pFileMP3, riff.m_id3tag.GetComment());     // Rg
        SetGenreSI(pFileMP3, riff.m_id3tag.GetGenre());         // W
        {//gbNԍ
         // x/y `ɂȂĂ y ̕gbNƂď
            CString strTrackNo = riff.m_id3tag.GetTrackNo();
            TCHAR *trk_number = strTrackNo.GetBuffer();
            TCHAR *trk_total = _tcschr(trk_number, _T('/'));
            if (trk_total) {
                *trk_total++ = 0;
            }
            SetTrackNumberSI(pFileMP3, trk_number);
            if (trk_total) {
                SetTrackTotalSI(pFileMP3, trk_total);
            }
            strTrackNo.ReleaseBuffer();
        }
        {//fBXNԍ
         //x/y `ɂȂĂ y ̕fBXNƂď
            CString strDiscNo = riff.m_id3tag.GetDiscNo();
            TCHAR *disc_number = strDiscNo.GetBuffer();
            TCHAR *disc_total = _tcschr(disc_number, _T('/'));
            if (disc_total) {
                *disc_total++ = 0;
            }
            SetDiscNumberSI(pFileMP3, disc_number);
            if (disc_total) {
                SetDiscTotalSI(pFileMP3, disc_total);
            }
            strDiscNo.ReleaseBuffer();
        }
        SetSoftwareSI(pFileMP3, riff.m_id3tag.GetEncoder());        // GR[_
        SetCopyrightSI(pFileMP3, riff.m_id3tag.GetCopyright());     // 쌠
        SetWriterSI(pFileMP3, riff.m_id3tag.GetWriter());            // 쎌
        SetComposerSI(pFileMP3, riff.m_id3tag.GetComposer());       // 
        SetAlbumArtistSI(pFileMP3, riff.m_id3tag.GetAlbumArtist()); // Albm. A[eBXg
        SetOrigArtistSI(pFileMP3, riff.m_id3tag.GetOrigArtist());   // Orig.A[eBXg
        SetURLSI(pFileMP3, riff.m_id3tag.GetUrl());                 // URL
        SetEncodest(pFileMP3, riff.m_id3tag.GetEncodest());         // GR[hl
        SetEngineerSI(pFileMP3, riff.m_id3tag.GetEngineer());        // GWjAioŁj
    }

    //tH[}bg
    CString strFormat;
    CString strTime;
    if(_tcsicmp(ext, _T(".wav")) == 0){
        GetWaveAudioFormat(GetFullPath(pFileMP3), riff.GetStreamSize(),
                            strFormat, strTime, 0);

        if (riff.m_id3tag.IsEnable()) {
            if (riff.m_id3tag.GetVer() == 0x0200) {
                SetFormat(pFileMP3, nFileTypeWAVV22);
                SetFileTypeName(pFileMP3, _T("WAV(ID3v2.2)"));
            }
            if (riff.m_id3tag.GetVer() == 0x0300) {
                SetFormat(pFileMP3, nFileTypeWAVV22);
                SetFileTypeName(pFileMP3, _T("WAV(ID3v2.3)"));
            }
            if (riff.m_id3tag.GetVer() == 0x0400) {
                SetFormat(pFileMP3, nFileTypeWAVV22);
                SetFileTypeName(pFileMP3, _T("WAV(ID3v2.4)"));
            }
        } else {
            SetFormat(pFileMP3, nFileTypeWAV);
            SetFileTypeName(pFileMP3, _T("WAV"));
        }
    }
    else{
        CString strAudioFormat;
        CString strVideoFormat;
        CString strStreamFormat;
        BOOL bAvi = false;
        GetAviFormat(GetFullPath(pFileMP3), 
                     strAudioFormat, strVideoFormat, strStreamFormat,
                     strTime,  bAvi, 0);
        strFormat = strVideoFormat;
        if(!strFormat.IsEmpty() && !strStreamFormat.IsEmpty()){
            strFormat += _T(", ");
        }
        strFormat += strStreamFormat;
        if(!strFormat.IsEmpty() && !strAudioFormat.IsEmpty()){
            strFormat += _T(", ");
        }
        strFormat += strAudioFormat;

        SetFormat(pFileMP3, nFileTypeAVI);
        SetFileTypeName(pFileMP3, _T("AVI"));
    }
    SetAudioFormat(pFileMP3, strFormat);
    TCHAR *time = strTime.GetBuffer();
    //szTime = "xx:xx (xxxsec) ̂悤ɂȂĂ
    TCHAR *pszSec = _tcschr(time, _T('('));
    if(pszSec){
        pszSec++;
        TCHAR *end;
        int sec = _tcstol(pszSec, &end, 10);
        SetPlayTime(pFileMP3, sec);
    }
    strTime.ReleaseBuffer();
    return true;
}

bool WriteAttributeFileWAV(FILE_INFO *pFileMP3)
{
	CRiffSIF riff;

    TCHAR ext[_MAX_EXT];
	_tsplitpath(GetFullPath(pFileMP3), NULL, NULL, NULL, ext);
    if(_tcsicmp(ext, _T(".wav")) == 0){
        if(riff.Load(GetFullPath(pFileMP3),'W','A','V','E') != ERROR_SUCCESS){
            return false;
        }
    }
    else if(_tcsicmp(ext, _T(".avi")) == 0){
        if(riff.Load(GetFullPath(pFileMP3),'A','V','I',' ') != ERROR_SUCCESS){
            return false;
        }
    }
    else{
        return false;
    }
    //INAM ^Cg
	riff.SetField('I','N','A','M', GetTrackName(pFileMP3));
	riff.SetField('I','S','B','J', _T("")); /* 2005.12.26 mp3infpƓl ISBJ폜 */
	//IART A[eBXg
	riff.SetField('I','A','R','T', GetArtistName(pFileMP3));
	//IPRD Ao
	riff.SetField('I','P','R','D', GetAlbumName(pFileMP3));
	//ICMT Rg
	riff.SetField('I','C','M','T', GetComment(pFileMP3));
	//ICRD t
	riff.SetField('I','C','R','D', GetYear(pFileMP3));
	//IGNR W
	riff.SetField('I','G','N','R', GetGenre(pFileMP3));
	//ITRK gbNԍ
	riff.SetField('I','T','R','K', GetTrackNumber(pFileMP3));

    if (riff.m_id3tag.IsEnable()) {
        switch (nId3v2Version) {
        case 1: // v2.2
            riff.m_id3tag.SetVer(0x0200);
            break;
        case 2: // v2.3
            riff.m_id3tag.SetVer(0x0300);
            break;
        case 3: // v2.4
            riff.m_id3tag.SetVer(0x0400);
            break;
        default:
            break;
        }
        switch (nId3v2Encode) {
        case 1:
            riff.m_id3tag.SetCharEncode(CId3tagv2::ID3V2CHARENCODE_ISO_8859_1);
            break;
        case 2:
            riff.m_id3tag.SetCharEncode(CId3tagv2::ID3V2CHARENCODE_UTF_16);
            break;
        case 3:
            riff.m_id3tag.SetCharEncode(CId3tagv2::ID3V2CHARENCODE_UTF_8);
            break;
            //case 4:
            //  id3v2.SetCharEncode(CId3tagv2::ID3V2CHARENCODE_UTF_16BE);
            //  break;
        default:
            break;
        }

        // *** ^O̐ݒ ***
        riff.m_id3tag.SetTitle(GetTrackNameSI(pFileMP3));           // ^Cg
        riff.m_id3tag.SetArtist(GetArtistNameSI(pFileMP3));         // A[eBXg
        riff.m_id3tag.SetAlbum(GetAlbumNameSI(pFileMP3));           // Ao
        riff.m_id3tag.SetYear(GetYearSI(pFileMP3));                 // [X
        riff.m_id3tag.SetEncoder(GetSoftwareSI(pFileMP3));          // GR[_
        {//gbNԍ/gbN
         //gbNp ID  ID3v2 ɂ͂Ȃ̂ "gbNԍ/gbN" 
         //悤ȕɕϊăgbNɏ
            CString strTrackNumber = GetTrackNumberSI(pFileMP3);
            CString strTrackTotal = GetTrackTotalSI(pFileMP3);
            if (!strTrackNumber.IsEmpty() && !strTrackTotal.IsEmpty()) {
                strTrackNumber = strTrackNumber + _T("/") + strTrackTotal;
            }
            riff.m_id3tag.SetTrackNo(strTrackNumber);
        }
        {//fBXNԍ/fBXN
         //fBXNp ID  ID3v2 ɂ͂Ȃ̂ "fBXNԍ/fBXN" 
         //悤ȕɕϊăfBXNɏ
            CString strDiscNumber = GetDiscNumberSI(pFileMP3);
            CString strDiscTotal = GetDiscTotalSI(pFileMP3);
            if (!strDiscNumber.IsEmpty() && !strDiscTotal.IsEmpty()) {
                strDiscNumber = strDiscNumber + _T("/") + strDiscTotal;
            }
            riff.m_id3tag.SetDiscNo(strDiscNumber);
        }
        riff.m_id3tag.SetComment(GetCommentSI(pFileMP3));           // Rg
        riff.m_id3tag.SetCopyright(GetCopyrightSI(pFileMP3));       // 쌠
        riff.m_id3tag.SetWriter(GetWriterSI(pFileMP3));             // 쎌
        riff.m_id3tag.SetComposer(GetComposerSI(pFileMP3));         // 
        riff.m_id3tag.SetAlbumArtist(GetAlbumArtistSI(pFileMP3));   // Albm. A[eBXg
        riff.m_id3tag.SetOrigArtist(GetOrigArtistSI(pFileMP3));     // Orig.A[eBXg
        riff.m_id3tag.SetUrl(GetURLSI(pFileMP3));                   // URL
        riff.m_id3tag.SetEncodest(GetEncodest(pFileMP3));           // GR[hl
        riff.m_id3tag.SetEngineer(GetEngineerSI(pFileMP3));         // GWjAioŁj
                                                            // W
        //CString strGenre;
        //BYTE    byGenre;
        //byGenre = STEPGetGenreCode(GetGenreSI(pFileMP3));
        //if (!_tcslen(GetGenreSI(pFileMP3)) == 0) {
        //    if (byGenre == (BYTE)0xff || STEPIsUserGenre(GetGenreSI(pFileMP3))) strGenre.Format(_T("%s"), GetGenreSI(pFileMP3));
        //    else                       strGenre.Format(_T("(%d)%s"), STEPGetGenreCode(GetGenreSI(pFileMP3)), GetGenreSI(pFileMP3));
        //}
        //riff.m_id3tag.SetGenre(strGenre/* 2005.08.23 del , bOptID3v2GenreAddNumber*/);
        riff.m_id3tag.SetGenre(GetGenreSI(pFileMP3));
    }

    return riff.Save(NULL, GetFullPath(pFileMP3)) == ERROR_SUCCESS;
}

bool WINAPI RiffAppendId3Tag(FILE_INFO* pFileInfo, int nProcFlag, HWND hWnd)
{
    if (nProcFlag == 3) {
        return false;
    }
    if (GetFormat(pFileInfo) != nFileTypeWAV    && GetFormat(pFileInfo) != nFileTypeWAVV22 &&
        GetFormat(pFileInfo) != nFileTypeWAVV23 && GetFormat(pFileInfo) != nFileTypeWAVV24) {
        return true;
    }

    // OɃ^OXV
    if (isModify(pFileInfo)) {
        if (STEPWriteTag(pFileInfo) == false) {
            return false;
        }
    }

    if (ProcessWavTag(GetFullPath(pFileInfo), WavAppendId3Tag) != ERROR_SUCCESS) {
        return false;
    }

    // ēǂݍ
    STEPInitDataID3(pFileInfo);
    STEPInitDataSIF(pFileInfo);
    extern	bool LoadAttributeFileWAV(FILE_INFO*);
    LoadAttributeFileWAV(pFileInfo);

    return true;
}

bool WINAPI RiffRemoveId3Tag(FILE_INFO* pFileInfo, int nProcFlag, HWND hWnd)
{
    if (nProcFlag == 3) {
        return false;
    }
    if (GetFormat(pFileInfo) != nFileTypeWAV    && GetFormat(pFileInfo) != nFileTypeWAVV22 &&
        GetFormat(pFileInfo) != nFileTypeWAVV23 && GetFormat(pFileInfo) != nFileTypeWAVV24) {
        return true;
    }

    // OɃ^OXV
    if (isModify(pFileInfo)) {
        if (STEPWriteTag(pFileInfo) == false) {
            return false;
        }
    }

    if (ProcessWavTag(GetFullPath(pFileInfo), WavRemoveId3Tag) != ERROR_SUCCESS) {
        return false;
    }

    // ēǂݍ
    STEPInitDataID3(pFileInfo);
    STEPInitDataSIF(pFileInfo);
    extern	bool LoadAttributeFileWAV(FILE_INFO*);
    LoadAttributeFileWAV(pFileInfo);

    return true;
}

bool WINAPI RiffRemoveAllTags(FILE_INFO* pFileInfo, int nProcFlag, HWND hWnd)
{
    if (nProcFlag == 3) {
        return false;
    }
    if (GetFormat(pFileInfo) != nFileTypeWAV    && GetFormat(pFileInfo) != nFileTypeWAVV22 &&
        GetFormat(pFileInfo) != nFileTypeWAVV23 && GetFormat(pFileInfo) != nFileTypeWAVV24) {
        return true;
    }

    // OɃ^OXV
    if (isModify(pFileInfo)) {
        if (STEPWriteTag(pFileInfo) == false) {
            return false;
        }
    }

    if (ProcessWavTag(GetFullPath(pFileInfo), WavRemoveAllTags) != ERROR_SUCCESS) {
        return false;
    }

    // ēǂݍ
    STEPInitDataID3(pFileInfo);
    STEPInitDataSIF(pFileInfo);
    extern	bool LoadAttributeFileWAV(FILE_INFO*);
    LoadAttributeFileWAV(pFileInfo);

    return true;
}

bool WINAPI RiffRemoveJunkChunks(FILE_INFO* pFileInfo, int nProcFlag, HWND hWnd)
{
    if (nProcFlag == 3) {
        return false;
    }
    if (GetFormat(pFileInfo) != nFileTypeWAV    && GetFormat(pFileInfo) != nFileTypeWAVV22 &&
        GetFormat(pFileInfo) != nFileTypeWAVV23 && GetFormat(pFileInfo) != nFileTypeWAVV24) {
        return true;
    }

    // OɃ^OXV
    if (isModify(pFileInfo)) {
        if (STEPWriteTag(pFileInfo) == false) {
            return false;
        }
    }

    if (ProcessWavTag(GetFullPath(pFileInfo), WavRemoveJunkChunks) != ERROR_SUCCESS) {
        return false;
    }

    // ēǂݍ
    STEPInitDataID3(pFileInfo);
    STEPInitDataSIF(pFileInfo);
    extern	bool LoadAttributeFileWAV(FILE_INFO*);
    LoadAttributeFileWAV(pFileInfo);

    return true;
}

